package com.wanji.indicators.event.cross.conflictpoint.func;

import com.wanji.indicators.entity.BaseLaneInfo;
import com.wanji.indicators.model.CarTrackModel;
import com.wanji.indicators.model.CrossFrameModel;
import com.wanji.indicators.model.FrameModel;
import org.apache.commons.lang3.StringUtils;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ConflictLaneInfoCoFlatMap implements CoFlatMapFunction<CrossFrameModel, Map<String, BaseLaneInfo>, CrossFrameModel> {

    private Map<String, BaseLaneInfo> map = new HashMap();

    @Override
    public void flatMap1(CrossFrameModel frameModel, Collector<CrossFrameModel> collector) throws Exception {

        List<CarTrackModel> trackList = frameModel.getTrackList();

        List<CarTrackModel> resList = new ArrayList<>();

        for (CarTrackModel carTrack : trackList) {
            String entryLane = carTrack.getRoadnet().getLaneId();

            BaseLaneInfo baseLaneInfo = map.get(entryLane);
            if (baseLaneInfo != null) {
                carTrack.getRoadnet().setTurn(baseLaneInfo.getTurn());
            } else {
                continue;
            }
            resList.add(carTrack);
        }

        frameModel.setTrackList(resList);

        collector.collect(frameModel);
    }

    @Override
    public void flatMap2(Map<String, BaseLaneInfo> hashMap, Collector<CrossFrameModel> collector) throws Exception {
        this.map = hashMap;
    }
}
