package com.wanji.indicators.model;

import lombok.Data;

import java.io.Serializable;

/**
 * @author fengyi
 * @date 2023/3/1
 * @description
 */
@Data
public class CarTrackModel implements Serializable {
    /*******************************************/
    /*全域ID*/
    private String orgCode = "";
    /*车辆ID*/
    private Integer id;
    /*车牌号*/
    private String picLicense;
    /*车牌颜色*/
    private Integer licenseColor;
    /*车辆颜色*/
    private Integer originalColor;
    /*车辆类型*/
    private Integer originalType;
    /*路网数据*/
    private RoadNet roadnet;

    /*******************************************/

    /*格式化时间戳：yyyy-MM-dd HH:mm:ss.SSS*/
    private String timeStamp;
    /*数值时间戳*/
    private Long globalTimeStamp;
    /*经度*/
    private Double longitude;
    /*纬度*/
    private Double latitude;
    /*速度*/
    private Double speed;
    /*航向角*/
    private Double courseAngle;

    /*******************************************/

    @Data
    public static class RoadNet implements Serializable {
        /*路口ID*/
        private String crossId;
        /*路段ID*/
        private String rid;
        /*车道ID*/
        private String laneId;
        /*渠化ID*/
        private String segmentId;
        /*是否在路口范围内*/
        private int inCrossFlag;
        /*车道功能转向*/
        private Integer turn=0;

    }

    /***********扩展属性*********************************/
    //路口内旅行时间，单位秒
    private Integer travelTime=0;
    //待转区车道长度，单位米
    private Double waitingTurnLaneDist=0D;
}
