package com.wanji.indicators.service.impl;

import com.vividsolutions.jts.geom.*;
import com.wanji.indicators.entity.BaseLaneInfo;
import com.wanji.indicators.entity.BaseRidInfo;
import com.wanji.indicators.mapper.BaseLaneInfoMapper;
import com.wanji.indicators.service.BaseLaneInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.wanji.indicators.util.GeomsConvertUtil;
import com.wanji.indicators.util.Tools;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;

/**
* <p>
* 车道基础信息 服务实现类
* </p>
*
* @author fengyi
* @since 2023-04-06
*/
@Service
public class BaseLaneInfoServiceImpl extends ServiceImpl<BaseLaneInfoMapper, BaseLaneInfo> implements BaseLaneInfoService {

	@Resource
	 private BaseLaneInfoMapper baseLaneInfoMapper;

	@Override
	public List<BaseLaneInfo> findLaneRidInfo() {
		List<BaseLaneInfo> list = null;//baseLaneInfoMapper.findAllBaseLaneInfo();
		for (BaseLaneInfo model : list) {
			String wkt = model.getRidWkt();
			LineString lineString = GeomsConvertUtil.getLineString(wkt);
			double ridLength = lineString.getLength();
			model.setRidLength(ridLength);
		}
		return list;
	}

	@Override
	public Map<String,BaseLaneInfo> findLaneInfo(String crossList) {
		String[] arr = StringUtils.split(crossList,",");
		List<String> crosslist = Arrays.asList(arr);
		Map<String, Object> params = new HashMap<>();
		params.put("crossList", crosslist);
		params.put("type",2);
		List<Map<String, Object>> list = this.baseLaneInfoMapper.findCrossLaneInfo(params);
		// t.cross_id,t.road_id,t.rid,t.type,t.dir,count(*) lane_num,t.road_wkt

		Map<String,BaseLaneInfo> laneInfoMap = new HashMap<>();
 		for (Map<String, Object> dataMap : list) {

			String crossId = Tools.getMapValue("cross_id", dataMap);
			String rid = Tools.getMapValue("rid", dataMap);
			String laneId = Tools.getMapValue("lane_id", dataMap);
			String turn = Tools.getMapValue("turn", dataMap);

			BaseLaneInfo baseLaneInfo = new BaseLaneInfo();
			baseLaneInfo.setCrossId(crossId);
			baseLaneInfo.setRid(rid);
			baseLaneInfo.setId(laneId);
			baseLaneInfo.setTurn(Integer.valueOf(turn));
			laneInfoMap.put(laneId,baseLaneInfo);
		}
 		return  laneInfoMap	;
	}
}
